int slno, pirateflagidx, personalflagidx;

int curPlayerType = 1;

int faceid = -1;

string ProfileName;

void InitInterface(string iniName)
{
	GetLanguageParameters(); // MAXIMUS 30.07.2006
	GameInterface.title = "titleSelectStoryline";

// KK -->
	GameInterface.SHIP.current = 0;
	GameInterface.SHIP.ImagesGroup.t0 = "ICONS";
	GameInterface.SHIP.ImagesGroup.t1 = "SHIPS16";
	GameInterface.SHIP.ImagesGroup.t2 = "SHIPS1";
	GameInterface.SHIP.ImagesGroup.t3 = "SHIPS2";
	GameInterface.SHIP.ImagesGroup.t4 = "SHIPS3";
	GameInterface.SHIP.ImagesGroup.t5 = "SHIPS4";
	GameInterface.SHIP.pic1.str1 = "";
	GameInterface.SHIP.pic1.img1 = "ship back";
	GameInterface.SHIP.pic1.tex1 = 0;
	GameInterface.SHIP.pic1.str2 = "";
	GameInterface.SHIP.pic1.img2 = "";
	GameInterface.SHIP.pic1.tex2 = -1;
	GameInterface.SHIP.ListSize = 1;
	GameInterface.SHIP.NotUsed = 1;
// <-- KK

	SendMessage(&GameInterface,"ls",MSG_INTERFACE_INIT,iniName);
	CreateExitString();//MAXIMUS: standard exit-string for exit-button

	ref PChar = GetMainCharacter();

	slno = FindDefaultStoryline();
	ProfileName =  DEFAULT_PROFILE_NAME;

	CreateString(true, "StorylineTitle", GetStorylineTitle(slno), FONT_NORMAL, COLOR_NORMAL, 320, 84, SCRIPT_ALIGN_CENTER, 1.0);
	CreateString(true, "Profile", "", FONT_SEADOGS, COLOR_NORMAL, 317, 481, SCRIPT_ALIGN_CENTER, 0.9);
	CreateString(true, "CharacterName", "", FONT_SEADOGS, COLOR_NORMAL, 124, 375, SCRIPT_ALIGN_CENTER, 0.9);
	CreateString(true, "ShipName", "", FONT_SEADOGS, COLOR_NORMAL, 516, 375, SCRIPT_ALIGN_CENTER, 0.9);
	CreateString(true, "lblProfile", TranslateString("", "Profile") + ":", FONT_NORMAL, COLOR_NORMAL, 215, 482, SCRIPT_ALIGN_LEFT, 0.7);
	CreateString(true, "lblStartDate", TranslateString("", "Date") + ":", FONT_NORMAL, COLOR_NORMAL, 200, 240, SCRIPT_ALIGN_LEFT, 0.7);
	CreateString(true, "lblNation", TranslateString("", "Nation") + ":", FONT_NORMAL, COLOR_NORMAL, 240, 240, SCRIPT_ALIGN_LEFT, 0.7);
	CreateString(true, "StartDate", "", FONT_NORMAL, COLOR_NORMAL, 200, 260, SCRIPT_ALIGN_LEFT, 0.7);
	CreateString(true, "StartLocation", TranslateString("", "Initial location") + ": " + TranslateString("", "unknown"), FONT_NORMAL, COLOR_NORMAL, 200, 280, SCRIPT_ALIGN_LEFT, 0.7);
	CreateString(true, "LblDifficulty", TranslateString("", "Difficulty") + ":", FONT_NORMAL, COLOR_NORMAL, 200, 310, SCRIPT_ALIGN_LEFT, 0.7);
	CreateString(true, "Difficulty", "", FONT_NORMAL, COLOR_NORMAL, 360, 310, SCRIPT_ALIGN_CENTER, 0.7);
	CreateString(AUTO_SKILL_SYSTEM, "lblPlayerType", TranslateString("", "Character is") + ":", FONT_NORMAL, COLOR_NORMAL, 200, 344, SCRIPT_ALIGN_LEFT, 0.7);
	CreateString(AUTO_SKILL_SYSTEM, "PlayerType", "", FONT_NORMAL, COLOR_NORMAL, 360, 344, SCRIPT_ALIGN_CENTER, 0.7);
	SetNodeUsing("PLAYER_TYPE", AUTO_SKILL_SYSTEM);

	SetFormatedText("INFO_TEXT", GetStorylineDescription(slno));
	SendMessage(&GameInterface,"lsl",MSG_INTERFACE_MSG_TO_NODE,"INFO_TEXT",5);

	if (GetStorylinesQuantity() == 1) {
		SetNodeUsing("STORYLINE", false);
		SetNodeUsing("RAMKA", true);
		SetNodeUsing("BOX", true);
	}

	SetSelectable("CUSTOMIZE_BUTTON", false); // PB: Unfinished interface

	SetVariables();

	SetEventHandler("InterfaceBreak","ProcessCancelExit",0);
	SetEventHandler("exitCancel","ProcessCancelExit",0);
	SetEventHandler("ievnt_command","ProcCommand",0);
	SetEventHandler("IEvnt_MouseClick", "IProcMouseClick", 0);
	SetEventHandler("ChangeStorylineLeft", "DoStorylineChangeLeft", 0);
	SetEventHandler("ChangeStorylineRight", "DoStorylineChangeRight", 0);
	SetEventHandler("ProfileOk","ProcessProfileOk",0);
	SetEventHandler("ProfileCancel","ProcessProfileCancel",0);
	SetEventHandler("ProfileChange","ProcessProfileChange",0);
	SetEventHandler("KB_End","WriteProfile",0);
	SetEventHandler("KB_Update", "UpdateProfile", 0);
	SetEventHandler("NodeOk","ProcessNodeOk",0);
	SetEventHandler("NodeCancel","ProcessNodeCancel",0);
	SetEventHandler("CharNameChange","ProcessCharNameChange",0);
	SetEventHandler("KB_End","WriteName",0);
	SetEventHandler("KB_Update", "UpdateName", 0);	
	SetEventHandler("ShipOk","ProcessShipOk",0);
	SetEventHandler("ShipCancel","ProcessShipCancel",0);
	SetEventHandler("ShipNameChange","ProcessShipNameChange",0);
	SetEventHandler("KB_End","WriteShipName",0);
	SetEventHandler("KB_Update", "UpdateShipName", 0);
	SetEventHandler("ChangeNationLeft", "DoChangeNationLeft", 0);
	SetEventHandler("ChangeNationRight", "DoChangeNationRight", 0);
	SetEventHandler("ChangeDifficultyLeft", "DoChangeDifficultyLeft", 0);
	SetEventHandler("ChangeDifficultyRight", "DoChangeDifficultyRight", 0);
	SetEventHandler("ChangePlayerTypeLeft", "DoChangePlayerTypeLeft", 0);
	SetEventHandler("ChangePlayerTypeRight", "DoChangePlayerTypeRight", 0);
	SetEventHandler("ProcessMessageBoxYes", "ProcessStartGameConfirm_yes", 0);
	SetEventHandler("ProcessMessageBoxNo", "ProcessStartGameConfirm_no", 0);
	SetEventHandler("UpStep", "DoUpStep", 0);
	SetEventHandler("DownStep", "DoDownStep", 0);
}

void ProcessCancelExit()
{
	IDoExit(RC_INTERFACE_SELECT_STORYLINE_EXIT);
	if( !CheckAttribute(&InterfaceStates,"InstantExit") || sti(InterfaceStates.InstantExit)==false )
	{
		ReturnToMainMenu();
	}
}

void IDoExit(int exitCode)
{
	DeleteAttribute(GameInterface, "pictures.nationPicture");

	DelEventHandler("InterfaceBreak","ProcessCancelExit");
	DelEventHandler("exitCancel","ProcessCancelExit");
	DelEventHandler("ievnt_command","ProcCommand");
	DelEventHandler("IEvnt_MouseClick", "IProcMouseClick");
	DelEventHandler("ChangeStorylineLeft", "DoStorylineChangeLeft");
	DelEventHandler("ChangeStorylineRight", "DoStorylineChangeRight");
	DelEventHandler("ShipOk","ProcessProfileOk");
	DelEventHandler("ShipCancel","ProcessProfileCancel");
	DelEventHandler("ShipNameChange","ProcessProfileChange");
	DelEventHandler("KB_End","WriteProfile");
	DelEventHandler("KB_Update", "UpdateProfile");
	DelEventHandler("NodeOk","ProcessNodeOk");
	DelEventHandler("NodeCancel","ProcessNodeCancel");
	DelEventHandler("CharNameChange","ProcessCharNameChange");
	DelEventHandler("KB_End","WriteName");
	DelEventHandler("KB_Update", "UpdateName");	
	DelEventHandler("ShipOk","ProcessShipOk");
	DelEventHandler("ShipCancel","ProcessShipCancel");
	DelEventHandler("ShipNameChange","ProcessShipNameChange");
	DelEventHandler("KB_End","WriteShipName");
	DelEventHandler("KB_Update", "UpdateShipName");
	DelEventHandler("ChangeNationRight", "DoChangeNationRight");
	DelEventHandler("ChangeNationLeft", "DoChangeNationLeft");
	DelEventHandler("ChangeDifficultyLeft", "DoChangeDifficultyLeft");
	DelEventHandler("ChangeDifficultyRight", "DoChangeDifficultyRight");
	DelEventHandler("ChangePlayerTypeLeft", "DoChangePlayerTypeLeft");
	DelEventHandler("ChangePlayerTypeRight", "DoChangePlayerTypeRight");
	DelEventHandler("ProcessMessageBoxYes", "ProcessStartGameConfirm_yes");
	DelEventHandler("ProcessMessageBoxNo", "ProcessStartGameConfirm_no");
	DelEventHandler("UpStep", "DoUpStep");
	DelEventHandler("DownStep", "DoDownStep");

	interfaceResultCommand = exitCode;
	EndCancelInterface(true);
}

void ProcCommand()
{
	string comName = GetEventData();
	string nodName = GetEventData();

	switch (nodName) {
		case "CUSTOMIZE_BUTTON":
			if (comName == "activate" || comName == "click") {
				IDoExit(RC_INTERFACE_DO_CUSTOMIZATION);
			}
		break;

		case "START_GAME_BUTTON":
			if (comName == "activate" || comName == "click") {
				if (!CheckProfiles(GameInterface.strings.Profile)) {
					ProcessStartGameConfirm();
					return;
				}
				ProcessStartGame();
			}
		break;
	}
}

// KK -->
void ProcessStartGameConfirm()
{
	SetNodeUsing("MESSAGEBOX", true);
	SetNodeUsing("MESSAGEBOX_TEXT", true);
	SetNodeUsing("MESSAGEBOX_BUTTON_NO", true);
	SetNodeUsing("MESSAGEBOX_BUTTON_YES", true);
	SetFormatedText("MESSAGEBOX_TEXT", TranslateString("", "Delete profile with all saved games and create new one?"));
	SetCurrentNode("MESSAGEBOX_BUTTON_NO");
	SendMessage(&GameInterface, "lls", MSG_INTERFACE_LOCK_NODE, 1, "MESSAGEBOX_BUTTON_NO");
	SendMessage(&GameInterface, "lls", MSG_INTERFACE_LOCK_NODE, 2, "MESSAGEBOX_BUTTON_YES");
}

void ProcessStartGameConfirm_yes()
{
	Event("ProcessMessageBoxNo");
	DeleteProfile(GetStoryline(slno), GameInterface.strings.Profile);
	ProcessStartGame();
}

void ProcessStartGameConfirm_no()
{
	SetNodeUsing("MESSAGEBOX", false);
	SetNodeUsing("MESSAGEBOX_TEXT", false);
	SetNodeUsing("MESSAGEBOX_BUTTON_NO", false);
	SetNodeUsing("MESSAGEBOX_BUTTON_YES", false);
	SetCurrentNode("START_GAME_BUTTON");
	SendMessage(&GameInterface,"ll", MSG_INTERFACE_LOCK_NODE, 0);
}

void ProcessStartGame()
{
	aref arstart = GetStorylineStartParams(slno);
	SetCurrentStoryline(slno);
	// It seems to be important that setcurrentstoryline is before setcurrentprofile to avoid some errors
	CreateProfile(GetStoryline(slno), GameInterface.strings.Profile);
	SetCurrentProfile(GetStoryline(slno), GameInterface.strings.Profile);
	CurrentStoryline = slno; // Screwface
	CurrentProfile = GameInterface.strings.Profile; // Screwface
	musicName = "";
	oldMusicName = "";
	ResetSoundScheme();
	StopSound(0,0);
	ReleaseSound(0);
	CharModel = arstart.model;
	int idx = GetModelIndex(CharModel);
	CharSex = Models[idx].sex;
	CharAni = Models[idx].ani;
	CharStore = GetTownStoreIndex(GetTownIDFromLocID(arstart.port));
	if(CharSex=="woman") { CharCommerce = CharCommerce+1; CharSneak = CharSneak+1; }
	if (CheckAttribute(arstart, "ship"))
		CharShipType = arstart.ship;
	else
		CharShipType = SHIP_NOTUSED_TYPE_NAME;
	CharPirateFlag = pirateflagidx;
	CharPersonalFlag = personalflagidx;
	CharLocation = 0;
	if (AUTO_SKILL_SYSTEM) SetCharacterSkillBonus(curPlayerType);
	LaunchGame();
	IDoExit(RC_INTERFACE_SELECT_STORYLINE_EXIT);
}
// <-- KK

void IProcMouseClick()
{
	string nodName = GetEventData();
	int btnCode = GetEventData();

	if (nodName == "STORYLINE") {
		if (btnCode == 0) Event("ChangeStorylineLeft");
		if (btnCode == 1) Event("ChangeStorylineRight");
	}

	if (nodName == "NATION_CHANGER") {
		if (btnCode == 0) Event("ChangeNationLeft");
		if (btnCode == 1) Event("ChangeNationRight");
	}

	if (nodName == "DIFFICULTY") {
		if (btnCode == 0) Event("ChangeDifficultyLeft");
		if (btnCode == 1) Event("ChangeDifficultyRight");
	}

	if (nodName == "PLAYER_TYPE") {
		if (btnCode == 0) Event("ChangePlayerTypeLeft");
		if (btnCode == 1) Event("ChangePlayerTypeRight");
	}
}

void DoStorylineChangeLeft()
{
	slno--;
	if (slno < 0) slno = GetStorylinesQuantity() - 1;
	GameInterface.strings.StorylineTitle = GetStorylineTitle(slno);
	SetFormatedText("INFO_TEXT", GetStorylineDescription(slno));
	SendMessage(&GameInterface,"lsl",MSG_INTERFACE_MSG_TO_NODE,"INFO_TEXT",5);
	SetVariables();
}

void DoStorylineChangeRight()
{
	slno++;
	if (slno >= GetStorylinesQuantity()) slno = 0;
	GameInterface.strings.StorylineTitle = GetStorylineTitle(slno);
	SetFormatedText("INFO_TEXT", GetStorylineDescription(slno));
	SendMessage(&GameInterface,"lsl",MSG_INTERFACE_MSG_TO_NODE,"INFO_TEXT",5);
	SetVariables();
}

void SetVariables()
{
	CharNation = PERSONAL_NATION;
	CharDifficulty = 1;
	curPlayerType = 1;

	SetNewPicture("DEFAULT_CHARACTER", "interfaces\empty_face.tga");
	GameInterface.strings.Profile = ProfileName;
	GameInterface.strings.CharacterName = "";
	GameInterface.strings.ShipName = "";
	GameInterface.SHIP.pic1.str1 = "";
	GameInterface.SHIP.pic1.img1 = "ship back";
	GameInterface.SHIP.pic1.tex1 = 0;
	GameInterface.SHIP.pic1.str2 = "";
	GameInterface.SHIP.pic1.img2 = "ship back";
	GameInterface.SHIP.pic1.tex2 = 0;
	SetNodeUsing("B_SHIPNAME", false);
	GameInterface.strings.StartDate = TranslateString("", "unknown");
	GameInterface.strings.StartLocation = TranslateString("", "Initial location") + ": " + TranslateString("", "unknown");

	aref arstart = GetStorylineStartParams(slno);
	string id = "";
	int idx = -1;
	if (CheckAttribute(arstart, "model")) {
		id = arstart.model;
		idx = GetModelIndex(id);
		if (idx < 0) {
			id = "Blaze";
			idx = GetModelIndex(id);
		}
		faceid = sti(Models[idx].FaceId);
		if (CheckAttribute(arstart, "name") && CheckAttribute(arstart, "lastname")) {
			CharFirstName = arstart.name;
			CharOldFirstName = CharFirstName;
			CharLastName = arstart.lastname;
			CharOldLastName = CharLastName;
		} else {
			CharFirstName = "Nathaniel";
			CharOldFirstName = CharFirstName;
			CharLastName = "Hawk";
			CharOldLastName = CharLastName;
		}
		if (CheckAttribute(arstart, "middlename")) {
			CharMiddleName = arstart.middlename;
			CharOldMiddleName = CharMiddleName;
		} else {
			CharMiddleName = "";
			CharOldMiddleName = "";
		}
		if (faceid >= 0)
			SetNewPicture("DEFAULT_CHARACTER", "interfaces\portraits\128\face_" + faceid + ".tga");
		else
			SetNewPicture("DEFAULT_CHARACTER", "interfaces\empty_face.tga");
		GameInterface.strings.CharacterName = "";
		if (CharFirstName != "" || CharMiddleName != "" || CharLastName != "") {
			if (CharFirstName != "") GameInterface.strings.CharacterName = CharFirstName + " ";
			if (CharMiddleName != "") GameInterface.strings.CharacterName = GameInterface.strings.CharacterName + CharMiddleName + " ";
			if (CharLastName != "") GameInterface.strings.CharacterName = GameInterface.strings.CharacterName + CharLastName;
		}
	} else {
		SetNewPicture("DEFAULT_CHARACTER", "interfaces\empty_face.tga");
	}
	if (CheckAttribute(arstart, "ship")) {
		id = arstart.ship;
		idx = GetShipIndex(id);
		if (idx > -1) {
			if (CheckAttribute(arstart, "shipname")) {
				CharShipName = arstart.shipname;
				GameInterface.strings.ShipName = CharShipName;
			}
			GameInterface.SHIP.pic1.str1 = "#" + ShipsTypes[idx].Class;
			GameInterface.SHIP.pic1.str2 = ShipsTypes[idx].SName;
			GameInterface.SHIP.pic1.img2 = GetShipPicName(idx);
			GameInterface.SHIP.pic1.tex2 = 1 + GetShipTexture(idx); // PB
		}
		SetNodeUsing("B_SHIPNAME", true);
	}
	SendMessage(&GameInterface, "ls", MSG_INTERFACE_REFRESH_SCROLL, "SHIP");

	if (CheckAttribute(arstart, "date.year")) {
		int year = GetDataYear();
		if (CheckAttribute(arstart, "date.year")) year = sti(arstart.date.year);
		int month = GetDataMonth();
		if (CheckAttribute(arstart, "date.month")) month = sti(arstart.date.month);
		int day = GetDataDay();
		if (CheckAttribute(arstart, "date.day")) day = sti(arstart.date.day);
		string time = GetStringTime(GetTime());
		if (CheckAttribute(arstart, "date.hour") && CheckAttribute(arstart, "date.min"))
			time = arstart.date.hour + ":" + arstart.date.min;
		GameInterface.strings.StartDate = TranslateString("", GetPeriodName(GetPeriodFromYear(sti(arstart.date.year)))) + " - " + GetHumanDate(year, month, day);
	}
	SetCurrentPeriod(GetPeriodFromYear(year)); // PB
	if (CheckAttribute(arstart, "location")) {
		int lidx = FindLocation(arstart.location);
		if (lidx >= 0 && CheckAttribute(Locations[lidx], "id.label")) {
			Preprocessor_Add("town_name", FindTownName(GetTownIDFromLocID(arstart.location)));
			Preprocessor_Add("island_name", FindIslandName(FindIslandByLocation(arstart.location)));
			GameInterface.strings.StartLocation = TranslateString("", "Initial location") + ": " + PreprocessText(TranslateString("", Locations[FindLocation(arstart.location)].id.label));
			Preprocessor_Remove("island_name");
			Preprocessor_Remove("town_name");
		}
	}
	pirateflagidx = 0;
	personalflagidx = 0;
	if (CheckAttribute(arstart, "Flags")) {
		if (CheckAttribute(arstart, "Flags.Pirate")) pirateflagidx = sti(arstart.Flags.Pirate);
		if (CheckAttribute(arstart, "Flags.Personal")) personalflagidx = sti(arstart.Flags.Personal);
	}
	// PB -->
	if (CheckAttribute(arstart, "nation")) {
		CharNation = sti(arstart.nation);
	}
	if (CheckAttribute(arstart, "playertype")) {
		curPlayerType = sti(arstart.playertype);
	}
	if (CheckAttribute(arstart, "difficulty")) {
		CharDifficulty = sti(arstart.difficulty);
	}

	SetNodeUsing("CUSTOMIZE_BUTTON", CheckAttribute(arstart, "freeplay"));

	//SetNodeUsing("DIFFICULTY",  !CheckAttribute(arstart, "locked"));
	SetNodeUsing("PLAYER_TYPE", !CheckAttribute(arstart, "locked") && AUTO_SKILL_SYSTEM);
	SetNodeUsing("NATION_CHANGER", !CheckAttribute(arstart, "locked"));
	SetNodeUsing("B_CHARNAME", !CheckAttribute(arstart, "locked"));
	SetNodeUsing("B_SHIPNAME", !CheckAttribute(arstart, "locked"));
	// PB <--
	GameInterface.strings.Difficulty = TranslateString("", GetDifficultyNameFromListNumber(CharDifficulty));
	if (AUTO_SKILL_SYSTEM) GameInterface.strings.PlayerType = TranslateString("", GetPlayerTypeFromListNumber(curPlayerType));
	SetNewFlagImage();
}

void SetNewFlagImage()
{
	string flagpic = "";
	switch (CharNation) {
		case PIRATE:
			flagpic = "Pirate" + pirateflagidx;
		break;
		case PERSONAL_NATION:
			flagpic = "Personal" + personalflagidx;
		break;
		// default:
			flagpic = GetFlagPicName(CharNation);
	}
	CreateImage("nationFlag", "NATIONS", flagpic, 300, 230, 332, 262);
	GameInterface.pictures.nationPicture = CharNation;
}

void DoChangeNationRight()
{
	if (CharNation < NATIONS_QUANTITY - 1)
		CharNation++;
	else
		CharNation = PERSONAL_NATION;
	SetNewFlagImage();
}

void DoChangeNationLeft()
{
	if (CharNation == PERSONAL_NATION) CharNation = NATIONS_QUANTITY;
	CharNation--;
	SetNewFlagImage();
}

void DoChangeDifficultyRight()
{
	if (CharDifficulty < 4)
		CharDifficulty++;
	else
		CharDifficulty = 4;
	GameInterface.strings.Difficulty = TranslateString("", GetDifficultyNameFromListNumber(CharDifficulty));
}

void DoChangeDifficultyLeft()
{
	if (CharDifficulty > 1)
		CharDifficulty--;
	else
		CharDifficulty = 1; 
	GameInterface.strings.Difficulty = TranslateString("", GetDifficultyNameFromListNumber(CharDifficulty));
}

string GetDifficultyNameFromListNumber(int inum)
{          
	string retstr;
	switch(inum)
	{
		case 1: retstr = "Apprentice"; break;
		case 2: retstr = "Journeyman"; break;
		case 3: retstr = "Adventurer"; break;
		case 4: retstr = "Swashbuckler"; break;
		retstr = "Unknown";
	}
	return retstr;
}

void DoChangePlayerTypeRight()
{
	if (curPlayerType < 5)
		curPlayerType++;
	else
		curPlayerType = 5; 
	GameInterface.strings.PlayerType = TranslateString("", GetPlayerTypeFromListNumber(curPlayerType));
}

void DoChangePlayerTypeLeft()
{
	if (curPlayerType > 1)
		curPlayerType--;
	else
		curPlayerType = 1;
	GameInterface.strings.PlayerType = TranslateString("", GetPlayerTypeFromListNumber(curPlayerType)); 
}

string GetPlayerTypeFromListNumber(int inum)
{          
	string retstr;
	switch(inum)
	{
		case PLAYER_TYPE_MERCHANT:			retstr = "Merchant"; break;
		case PLAYER_TYPE_MILITARY:			retstr = "Military"; break;
		case PLAYER_TYPE_ADVENTURER:		retstr = "Adventurer"; break;
		case PLAYER_TYPE_SOCIAL_CLIMBER:	retstr = "Social climber"; break;
		case PLAYER_TYPE_CORSAIR:			retstr = "Corsair"; break;
		retstr = "Unknown";
	}
	return retstr;
}

void ProcessProfileOk()
{
	string nodName = GetEventData();
	if( CheckAttribute(&GameInterface,nodName+".strdata") )
	{
		string str = GameInterface.(nodName).strdata;
		ProfileName = str;
		GameInterface.strings.Profile = ProfileName;
	}
	DeleteAttribute(&GameInterface,nodName+".strdata");
}

void ProcessProfileCancel()
{
	string nodName = GetEventData();
	DeleteAttribute(&GameInterface,nodName+".strdata");
	GameInterface.strings.Profile = ProfileName;
	SetCurrentNode("BOX2");
}

void ProcessProfileChange()
{
	ChangeStringColor("Profile", COLOR_MONEY);
	SendMessage(&GameInterface,"lls", MSG_INTERFACE_LOCK_NODE, 1, "PROFILE_BORDER");
	SetCurrentNode("PROFILE_BORDER"); 
	KB_SetKeyboardMode(true);
	KB_Prepare(GameInterface.strings.Profile);
}

void UpdateProfile()
{
	if(GetCurrentNode() == "PROFILE_BORDER") GameInterface.strings.Profile = KeyboardDisplayString;
}

void WriteProfile()
{
	if(GetCurrentNode()=="PROFILE_BORDER")
	{
		if(KeyboardString!="")
		{
			ProfileName = KeyboardString;
			GameInterface.strings.Profile = KeyboardString;
		}
		else
		{
			GameInterface.strings.Profile = ProfileName;
			ProcessShipCancel();
		}
	}
	ChangeStringColor("Profile", COLOR_NORMAL);
}

void ProcessNodeOk()
{
	string nodName = GetEventData();
	if( CheckAttribute(&GameInterface,nodName+".strdata") )
	{
		string str = GameInterface.(nodName).strdata;
		SetMainCharacterName(str);
		GameInterface.strings.CharacterName = "";
		if (CharFirstName != "") GameInterface.strings.CharacterName = CharFirstName + " ";
		if (CharMiddleName != "") GameInterface.strings.CharacterName = GameInterface.strings.CharacterName + CharMiddleName + " ";
		if (CharLastName != "") GameInterface.strings.CharacterName = GameInterface.strings.CharacterName + CharLastName;
	}
	DeleteAttribute(&GameInterface,nodName+".strdata");
}

void ProcessNodeCancel()
{
	string nodName = GetEventData();
	DeleteAttribute(&GameInterface,nodName+".strdata");
	GameInterface.strings.CharacterName = "";
	if (CharFirstName != "") GameInterface.strings.CharacterName = CharFirstName + " ";
	if (CharMiddleName != "") GameInterface.strings.CharacterName = GameInterface.strings.CharacterName + CharMiddleName + " ";
	if (CharLastName != "") GameInterface.strings.CharacterName = GameInterface.strings.CharacterName + CharLastName;
	SetCurrentNode("BOX1");
}

void ProcessCharNameChange()
{
	ChangeStringColor("CharacterName", COLOR_MONEY);
	SendMessage(&GameInterface,"lls", MSG_INTERFACE_LOCK_NODE, 1, "BOX1");
	SetCurrentNode("BOX1");
	KB_SetKeyboardMode(true);
	KB_Prepare(GameInterface.strings.CharacterName); // KK
}

void UpdateName()
{
	if(GetCurrentNode() == "BOX1") GameInterface.strings.CharacterName = KeyboardDisplayString; // KK
}

void WriteName()
{
	if(GetCurrentNode() == "BOX1")
	{
		if(KeyboardString != "")
		{
			SetMainCharacterName(KeyboardString);
			GameInterface.strings.CharacterName = KeyboardString;
		}
		else
		{
			GameInterface.strings.CharacterName = "";
			if (CharFirstName != "") GameInterface.strings.CharacterName = CharFirstName + " ";
			if (CharMiddleName != "") GameInterface.strings.CharacterName = GameInterface.strings.CharacterName + CharMiddleName + " ";
			if (CharLastName != "") GameInterface.strings.CharacterName = GameInterface.strings.CharacterName + CharLastName;
			ProcessNodeCancel();
		}
		SetNodeUsing("BOX",false);
	}
	ChangeStringColor("CharacterName", COLOR_NORMAL);
}

void ProcessShipOk()
{
	string nodName = GetEventData();
	if( CheckAttribute(&GameInterface,nodName+".strdata") )
	{
		string str = GameInterface.(nodName).strdata;
		CharShipName = str;
		GameInterface.strings.ShipName = CharShipName;
	}
	DeleteAttribute(&GameInterface,nodName+".strdata");
}

void ProcessShipCancel()
{
	string nodName = GetEventData();
	DeleteAttribute(&GameInterface,nodName+".strdata");
	aref arstart = GetStorylineStartParams(FindStoryline(GetStoryline(slno)));
	GameInterface.strings.ShipName = arstart.shipname;
	SetCurrentNode("BOX2");
}

void ProcessShipNameChange()
{
	ChangeStringColor("ShipName", COLOR_MONEY);
	SendMessage(&GameInterface,"lls", MSG_INTERFACE_LOCK_NODE, 1, "BOX2");
	SetCurrentNode("BOX2"); 
	KB_SetKeyboardMode(true);
	KB_Prepare(GameInterface.strings.ShipName); // KK
}

void UpdateShipName()
{
	if(GetCurrentNode() == "BOX2") GameInterface.strings.ShipName = KeyboardDisplayString; // KK
}

void WriteShipName()
{
	if(GetCurrentNode()=="BOX2")
	{
		if(KeyboardString!="")
		{
			CharShipName = KeyboardString;
			GameInterface.strings.ShipName = KeyboardString;
		}
		else
		{
			aref arstart = GetStorylineStartParams(FindStoryline(GetStoryline(slno)));
			GameInterface.strings.ShipName = CharShipName;//GetShipNameFromListNumber(nCurSScrollNum);
			ProcessShipCancel();
		}
	}
	ChangeStringColor("ShipName", COLOR_NORMAL);
}

bool CheckProfiles(string curProfile)
{
	ProfileName = curProfile;

	return GetProfileSavesQuantity(GetStoryline(slno), curProfile) == 0;
}

void DoUpStep()
{
	string tmp = NextUp(GetCurrentNode());
	SetCurrentNode(tmp);
}

void DoDownStep()
{
	string tmp = NextDown(GetCurrentNode());
	SetCurrentNode(tmp);
}

string NextUp(string curNode)
{
	switch (curNode)
	{
		case "STORYLINE":
			if (GetSelectable("START_GAME_BUTTON")) return "START_GAME_BUTTON"; else return NextUp("START_GAME_BUTTON");
		break;
		case "START_GAME_BUTTON":
			if (GetSelectable("CUSTOMIZE_BUTTON")) return "CUSTOMIZE_BUTTON"; else return NextUp("CUSTOMIZE_BUTTON");
		break;
		case "CUSTOMIZE_BUTTON":
			if (AUTO_SKILL_SYSTEM) {
				if (GetSelectable("PLAYER_TYPE")) return "PLAYER_TYPE"; else return NextUp("PLAYER_TYPE");
			} else {
				if (GetSelectable("DIFFICULTY")) return "DIFFICULTY"; else return NextUp("DIFFICULTY");
			}
		break;
		case "PLAYER_TYPE":
			if (GetSelectable("DIFFICULTY")) return "DIFFICULTY"; else return NextUp("DIFFICULTY");
		break;
		case "DIFFICULTY":
			if (GetSelectable("NATION_CHANGER")) return "NATION_CHANGER"; else return NextUp("NATION_CHANGER");
		break;
		case "NATION_CHANGER":
			if (GetSelectable("STORYLINE")) return "STORYLINE"; else return NextUp("STORYLINE");
		break;
	}
	return " ";
}

string NextDown(string curNode)
{
	switch (curNode)
	{
		case "STORYLINE":
			if (GetSelectable("NATION_CHANGER")) return "NATION_CHANGER"; else return NextDown("NATION_CHANGER");
		break;
		case "NATION_CHANGER":
			if (GetSelectable("DIFFICULTY")) return "DIFFICULTY"; else return NextDown("DIFFICULTY");
		break;
		case "DIFFICULTY":
			if (AUTO_SKILL_SYSTEM) {
				if (GetSelectable("PLAYER_TYPE")) return "PLAYER_TYPE"; else return NextDown("PLAYER_TYPE");
			} else {
				if (GetSelectable("CUSTOMIZE_BUTTON")) return "CUSTOMIZE_BUTTON"; else return NextDown("CUSTOMIZE_BUTTON");
			}
		break;
		case "PLAYER_TYPE":
			if (GetSelectable("CUSTOMIZE_BUTTON")) return "CUSTOMIZE_BUTTON"; else return NextDown("CUSTOMIZE_BUTTON");
		break;
		case "CUSTOMIZE_BUTTON":
			if (GetSelectable("START_GAME_BUTTON")) return "START_GAME_BUTTON"; else return NextDown("START_GAME_BUTTON");
		break;
		case "START_GAME_BUTTON":
			if (GetSelectable("STORYLINE")) return "STORYLINE"; else return NextDown("STORYLINE");
		break;
	}
	return " ";
}

//MAXIMUS: new skills-system -->
void SetCharacterSkillBonus(int playerType)
{
	float curSpeed = makefloat(stf(SKILLS_UP_BONUS+100)/100);

	CharBonusDifficulty = 1.0;
	CharBonusLeadership = 1.0;
	CharBonusFencing = 1.0;
	CharBonusSailing = 1.0;
	CharBonusAccuracy = 1.0;
	CharBonusCannons = 1.0;
	CharBonusGrappling = 1.0;
	CharBonusRepair = 1.0;
	CharBonusDefence = 1.0;
	CharBonusCommerce = 1.0;
	CharBonusSneak = 1.0;

	switch(playerType)
	{
		case PLAYER_TYPE_MERCHANT: CharBonusSailing = curSpeed; CharBonusCommerce = curSpeed; break;
		case PLAYER_TYPE_MILITARY: CharBonusAccuracy = curSpeed; CharBonusDefence = curSpeed; break;
		case PLAYER_TYPE_ADVENTURER: CharBonusFencing = curSpeed; CharBonusSneak = curSpeed; break;
		case PLAYER_TYPE_SOCIAL_CLIMBER: CharBonusLeadership = curSpeed; CharBonusRepair = curSpeed; break;
		case PLAYER_TYPE_CORSAIR: CharBonusCannons = curSpeed; CharBonusGrappling = curSpeed; break;
	}
}
//MAXIMUS: new skills-system <--
